/*---------------------------------------------------------------------------
  #######      #     #########   #          #   #    ########     #    #    #
  #            #     #            #        #    #    #            #    #    #
   ###         #    #              #      #     #    #####         #  # #  #
      ###      #    #    #####     #     #      #    #             #  # #  #
         #     #    #        #      #   #       #    #              # #  # #
  ##     #     #     ##      #       # #        #    #              ##   ##
    ####       #       ######         #         #    ########        #    #

    Designed and written by
    Lisa Pickel - pickel@mcnc.org 

    Copyright 1990, 1991 by MCNC.
    This program may be freely distributed provided that the
	copyright notice and author identification are retained.
--------------------------------------------------------------------------- */
#define G_MAXCOLORS	64
#define G_MAXLAYERS	12
#define G_PLANES	6
#define G_COLORS	1	
#define G_HILITE_BIT	8
#define G_LINESTYLES	7

/* here are my colors, defined as RGB values, each value representing the
   percentage of the color used from 0 to 1.  0 means 'no color' while 
   1 means 'full color'
*/
struct G_cmap_t {
	double red;
	double green;
	double blue;
}  G_cmap[] = { 
{0.2,	0.2,	0.2}, 	/* 0 bkgd, black */
{0.6,	0.6,	0.6},	/* 1 grey */
{0.7,	0.7,	0.0},	/* 2 yellow */
{1.0,	1.0,	1.0}, 	/* 3 white */
{1.0,	0.0,	0.0}, 	/* 4 red */
{0.0,	0.6,	0.0}, 	/* 5 green */
{0.7,	0.2,	0.7}, 	/* 6 purple */
{0.0,	0.6,	0.6}, 	/* 7 lt blue */

{0.1,	0.1,	0.1}, /*  8 bkgd hi, */
{0.8,	0.8,	0.8}, /*  9 grey hi */
{0.95,	0.95,	0.0}, /*  10 yellow hi */
{1.0,	1.0, 	1.0}, /* 11 white hi */
{0.9,	0.456,	0.5}, /* 12 red hi */
{0.7,	0.891,	0.7}, /* 13 green hi */
{1.0,	0.5,	1.0}, /* 14 purple hi */
{0.5,	0.891,	0.891}, /* 15 ltblue hi */

/* The color of the left vertical, one for each color */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */

{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */
{1.0,	0.8	,	0.8}, /* very light red */

/* The color of the right vertical, one for each color */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */

{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */
{0.8,	0.8	,	1.0}, /* very light blue */

/* Color of left and right vertical on top of each other, one for each color*/
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */

{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}, /* very light yellow */
{0.9,	0.9	,	0.7}}; /* very light yellow */

struct G_lmap_t { 
	short color,mask,bw,linestyle;
} G_lmap[] = {	/* Opaque layers */
/* 0 bkgd */			{0, 63, 0, -1}, /* linestyle -1 means solid line */
/* 1 dkblue */			{0, 63, 1, -1},
/* 2 textoverbkgd */	{3, 63, 1, -1},
/* 3 textovercolors */	{3, 63, 0, -1},
/* 4 red */				{4, 63, 1, -1},
/* 5 green */			{5, 63, 1, 3},
/* 6 yellow */ 		 	{2, 63, 1, 6}, 
/* 7 purple */			{6, 63, 1, 4},
/* 8 ltblue */ 		 	{7, 63, 1, 1},
/* 9 grey */			{1, 63, 1, 5},
/* 10 leftvert */		{16, 16, 1, -2}, /*linestyle -2 means use GXinvert*/
/* 11 rightvert */		{32, 32, 1, -2}
};


struct G_linestyle_t {
	int n_elems;	/* number of elements in dash list */
	char dash_list[8];
} G_linestyle[G_LINESTYLES] = {
	{4, {5, 1, 1, 5}},
	{2, {3, 3}},
	{4, {8, 4, 2, 4}},
	{8, {3, 2, 1, 1, 1, 1, 1, 2}}, /*good*/
	{8, {6, 2, 6, 2, 2, 2, 2, 2}},
	{7, {2, 2, 2, 2, 2, 2, 4}},
	{4, {5, 10, 10, 5}}
};
