/*---------------------------------------------------------------------------
  #######      #     #########   #          #   #    ########     #    #    #
  #            #     #            #        #    #    #            #    #    #
   ###         #    #              #      #     #    #####         #  # #  #
      ###      #    #    #####     #     #      #    #             #  # #  #
         #     #    #        #      #   #       #    #              # #  # #
  ##     #     #     ##      #       # #        #    #              ##   ##
    ####       #       ######         #         #    ########        #    #

    Designed and written by
    Lisa Pickel - pickel@mcnc.org 

    Copyright 1990, 1991 by MCNC.
    This program may be freely distributed provided that the
	copyright notice and author identification are retained.
--------------------------------------------------------------------------- */
#include "sigview.h"

extern int Sig_interactive_mode;

static double X = 10.0;
static double Y = 22.0;

/* I bet you're thinking, "gee what a lot of repeated code".  Yeah, well,
   it's late and I'm tired.  So there.  This function is used to
   output information about the files being read in.  It has a
   "wait" parameter to indicate whether one should wait for an
   event like a button hit before clearing the message. */

sig_file_msg(wait, s1, s2)
	char *s1, *s2;
	int wait;
{
	double len, graph_str_width();
	char buffer[BUFSIZE], *bufptr;
	int win_id, d1;
	double d2, d3;

	strcpy(buffer, s1);
	strcat(buffer, s2);
	strcat(buffer, " =-= ");

	if (Sig_interactive_mode) {
		/* remove any tabs or newlines and replace them with blanks */
		bufptr = buffer;
		while (*bufptr != '\0') {
			if ((*bufptr == '\n') || (*bufptr == '\t'))
				*bufptr = ' ';
			bufptr++;	
		}
		graph_char_just_set("ll"),
		graph_set_layer(2);

		len = graph_str_width(buffer);
		if ((X + len) > AXISRIGHT) {
			X = 10.0;
			Y = Y - 11.0;
		}
		if (Y < 11.0)
			return;

		graph_text(X, Y, buffer);
		/* leave X in position for the next msg */
		X = X + len;

		if (wait) {
			graph_char_just_set("bc"),
			graph_text(300.0, 1.0, "TO CONTINUE, PRESS ANY BUTTON OR KEY");
			graph_await_event(&win_id, &d1, &d2, &d3);
			end_command();
			graph_set_layer(0);
			graph_draw_mode(0);
			graph_rect(0.0, 0.0, 600.0, 44.0);
		
		}		
		else graph_flush();
	}
	else fprintf(stderr,"%s\n", buffer);
}

sig_msg(s1, s2, s3)
	char *s1, *s2, *s3;
{
	double len, graph_str_width();
	char buffer[BUFSIZE], *bufptr;
	int win_id, d1;
	double d2, d3;

	strcpy(buffer, s1);
	strcat(buffer, s2);
	strcat(buffer, s3);
	strcat(buffer, " =-= ");

	if (Sig_interactive_mode) {
		/* remove any tabs or newlines and replace them with blanks */
		bufptr = buffer;
		while (*bufptr != '\0') {
			if ((*bufptr == '\n') || (*bufptr == '\t'))
				*bufptr = ' ';
			bufptr++;	
		}
		graph_set_layer(0);
		graph_draw_mode(0);
		graph_rect(0.0, 0.0, 600.0, 44.0);
		
		graph_char_just_set("ll"),
		graph_set_layer(2);

		len = graph_str_width(buffer);
		if ((X + len) > AXISRIGHT) {
			X = 10.0;
			Y = Y - 11.0;
		}
		if (Y < 11.0)
			return;

		graph_text(X, Y, buffer);
		/* leave X in position for the next msg */
		X = X + len;

		graph_char_just_set("bc"),
		graph_text(300.0, 1.0, "TO CONTINUE, PRESS ANY BUTTON OR KEY");
		graph_await_event(&win_id, &d1, &d2, &d3);
	}
	else fprintf(stderr,"%s\n", buffer);
}

end_command()
{
	X = 10.0;
	Y = 22.0;
}
