/*---------------------------------------------------------------------------
  #######      #     #########   #          #   #    ########     #    #    #
  #            #     #            #        #    #    #            #    #    #
   ###         #    #              #      #     #    #####         #  # #  #
      ###      #    #    #####     #     #      #    #             #  # #  #
         #     #    #        #      #   #       #    #              # #  # #
  ##     #     #     ##      #       # #        #    #              ##   ##
    ####       #       ######         #         #    ########        #    #

    Designed and written by
    Lisa Pickel - pickel@mcnc.org 

    Copyright 1990, 1991 by MCNC.
    This program may be freely distributed provided that the
	copyright notice and author identification are retained.
--------------------------------------------------------------------------- */
#include <stdio.h>
#include <strings.h>

#include <X11/Xlib.h>

#define SMAX(__x, __y)	(((__x) > (__y)) ? (__x) : (__y))
#define SMIN(__x, __y)	(((__x) < (__y)) ? (__x) : (__y))
#define ABS(__x)		(((__x) < 0.0) ? (-__x) : (__x))

#define	TFILE 0
#define TDIRECT 1

typedef struct func_s func_t;
struct func_s{
	int (*init)();
	int (*color_map)();
	int (*window_set)();

	int (*font_set)();
	int (*char_just_set)();
	int (*text)();
	double (*str_width)();

	int (*set_layer)();

	int (*GtoWhatever)();
	int (*connect_dots)();
	int (*line)();

	int (*term)();
	int (*set_line_width)();
};

#define H_MAXCOLORS	8
#define H_MAXLAYERS	12

typedef struct H_cmap_s H_cmap_t;
struct H_cmap_s {
	float red;
	float green;
	float blue;
};
