/*---------------------------------------------------------------------------
  #######      #     #########   #          #   #    ########     #    #    #
  #            #     #            #        #    #    #            #    #    #
   ###         #    #              #      #     #    #####         #  # #  #
      ###      #    #    #####     #     #      #    #             #  # #  #
         #     #    #        #      #   #       #    #              # #  # #
  ##     #     #     ##      #       # #        #    #              ##   ##
    ####       #       ######         #         #    ########        #    #

    Designed and written by
    Lisa Pickel - pickel@mcnc.org 

    Copyright 1990, 1991 by MCNC.
    This program may be freely distributed provided that the
	copyright notice and author identification are retained.
--------------------------------------------------------------------------- */
#include "gp.h"

#define TEXTBEGIN	10.0
#define TEXTLINE1	45.0
#define TEXTLINE2	30.0
#define TEXTLINE3	15.0

help_msg(cmdname)
	char *cmdname;
{
	int d1,d4;
	double d2, d3;

        graph_set_layer(0);
        graph_rect(0.0, 0.0, 600.0, 44.0);
	graph_set_layer(2);

	if (*cmdname == '\0') {
		graph_text(TEXTBEGIN, TEXTLINE1-10, "Help for: addplot addsigs combine compare convert copy create delete(delaxes)");
		graph_text(TEXTBEGIN, TEXTLINE2-5, "delsigs format grid ft general help interval load logx logy mode notype nums precision");
		graph_text(TEXTBEGIN, TEXTLINE3, "quit run search show snapshot time transient units xaxis xscale xtics yaxes yrange ytics");
	}
	else if (strncmp(cmdname, "addplot", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: addplot expression");
		graph_text(TEXTBEGIN,TEXTLINE3,"Define a new plot and add to the plot area.");
	}
	else if (strncmp(cmdname, "addsigs", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: addsigs -a list-of-axes -s list-of-sigs -f list-of-runs");
		graph_text(TEXTBEGIN,TEXTLINE3,"Add the named signals from the named runs to the axes given.");
	}
	else if (strncmp(cmdname, "combine", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: combine axisname list-of-axes");
		graph_text(TEXTBEGIN,TEXTLINE3,"Combine existing axes into one.");
	}
	else if (strncmp(cmdname, "compare", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: compare -s list-of-sigs -f list-of-runs");
		graph_text(TEXTBEGIN,TEXTLINE3,"Display signals of the same name on the same axis.");
	}
	else if (strncmp(cmdname, "convert", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: convert axisname conversion");
		graph_text(TEXTBEGIN,TEXTLINE3,"Convert the values of a bus to hex, decimal, octal, or binary.");
	}
	else if (strncmp(cmdname, "copy", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: copy list-of-axes");
		graph_text(TEXTBEGIN,TEXTLINE3,"Make a copy of the given axis.");
	}
	else if (strncmp(cmdname, "create", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: create axisname -s list-of-sigs -f list-of-runs");
		graph_text(TEXTBEGIN,TEXTLINE3,"Create a new axis with all the given signals from the given runs on it.");
	}
	else if (strncmp(cmdname, "delaxes", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: delaxes list-of-axes");
		graph_text(TEXTBEGIN,TEXTLINE3,"Delete the named axes from the screen.");
	}
	else if (strncmp(cmdname, "delsigs", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: delsigs -a list-of-axes -s list-of-sigs -f list-of-runs");
		graph_text(TEXTBEGIN,TEXTLINE3,"Delete the named signals from the named runs from the axes given.");
	}
	else if (strncmp(cmdname, "format", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: format <integer>");
		graph_text(TEXTBEGIN,TEXTLINE3,"Specify the number of decimal places to display");
	}
	else if (strncmp(cmdname, "ft", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: ft vecname -nfreq int -ffreq real -q -f");
		graph_text(TEXTBEGIN,TEXTLINE3,"Perform fourier analysis and plot the results.");
	}
	else if (strncmp(cmdname, "general", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: general");
		graph_text(TEXTBEGIN,TEXTLINE3,"Spawn a new general mode window.");
	}
	else if (strncmp(cmdname, "grid", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: grid");
		graph_text(TEXTBEGIN,TEXTLINE3,"Toggle to superimpose grid over the plot area.");
	}
	else if (strncmp(cmdname, "help", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: help cmdname");
		graph_text(TEXTBEGIN,TEXTLINE3,"Get help for cmdname.");
	}
	else if (strncmp(cmdname, "interval", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2, "cmd format: interval [n | max]");
		graph_text(TEXTBEGIN,TEXTLINE3,"Change timespan in transient window to n or max.");
	}	
	else if (strncmp(cmdname, "load", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: load list-of-filenames");
		graph_text(TEXTBEGIN,TEXTLINE3,"Load data from CAZM, RNL, ESIM or Spice files.");
	}
	else if (strncmp(cmdname, "logx", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: logx");
		graph_text(TEXTBEGIN,TEXTLINE3,"Toggle X axis from LINEAR to LOG and back again.");
	}
	else if (strncmp(cmdname, "logy", 4) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: logy");
		graph_text(TEXTBEGIN,TEXTLINE3,"Toggle Y axis from LINEAR to LOG and back again.");
	}
	else if (strncmp(cmdname, "mode", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: mode axisname bus-or-normal -c hex-or-binary-or-etc.");
		graph_text(TEXTBEGIN,TEXTLINE3,"Change an axis to be displayed as a bus or revert it to normal.");
	}
	else if (strncmp(cmdname, "notype", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: notype");
		graph_text(TEXTBEGIN,TEXTLINE3,"Turn off/on need for keyboard input after selection of menu item.");
	}
	else if (strncmp(cmdname, "nums", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: nums ");
		graph_text(TEXTBEGIN,TEXTLINE3,"Show the values of each signal along the verticals.");
	}
	else if (strncmp(cmdname, "precision", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: precision ");
		graph_text(TEXTBEGIN,TEXTLINE3,"Toggle printing of numbers in scientific notation.");
	}
	else if (strncmp(cmdname, "quit", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: quit");
		graph_text(TEXTBEGIN,TEXTLINE3,"End this run of Sigview, close all windows.");
	}
	else if (strncmp(cmdname, "redraw", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: redraw");
		graph_text(TEXTBEGIN,TEXTLINE3,"Redraws the window to get rid of nasty leftovers.");
	}
	else if (strncmp(cmdname, "run", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: run list-of-cmdfilenames");
		graph_text(TEXTBEGIN,TEXTLINE3,"Run the commands in the command file(s) given.");
	}
	else if (strncmp(cmdname, "searchnext", 7) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: n  OR  /");
		graph_text(TEXTBEGIN,TEXTLINE3,"Find the next occurence of the pattern you just searched for.");
	}
	else if (strncmp(cmdname, "searchprevious", 7) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: p  OR  ?");
		graph_text(TEXTBEGIN,TEXTLINE3,"Find the previous occurence of the pattern you just searched for.");
	}
	else if (strncmp(cmdname, "search", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: see documentation--it is a bit complex.");
		graph_text(TEXTBEGIN,TEXTLINE3,"Search the axis for a bit pattern. See also 'searchnext' and 'searchprevious'.");
	}
	else if (strncmp(cmdname, "show", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: show -s list-of-sigs -f list-of-runs");
		graph_text(TEXTBEGIN,TEXTLINE3,"Plots each named signal.");
	}
	else if (strncmp(cmdname, "snapshot", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: snapshot -o devicename");
		graph_text(TEXTBEGIN,TEXTLINE3,"Send contents of window to file or plotter.");
	}
	else if (strncmp(cmdname, "time", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: time n -a list-of-axes");
		graph_text(TEXTBEGIN,TEXTLINE3,"Change the starting time of the axes given (defaults to all axes).");
	}
	else if (strncmp(cmdname, "transient", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: transient");
		graph_text(TEXTBEGIN,TEXTLINE3,"Create the transient mode window, if not already in existence.");
	}
	else if (strncmp(cmdname, "units", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: units n");
		graph_text(TEXTBEGIN,TEXTLINE3,"Set each digital vector to represent n of the current units (usually nanoseconds).");
	}
	else if (strncmp(cmdname, "xaxis", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: xaxis expression");
		graph_text(TEXTBEGIN,TEXTLINE3,"Set x axis vector to be the values produced by evaluating the given expression.");
	}
	else if (strncmp(cmdname, "xrange", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: xrange >xmin <xmax");
		graph_text(TEXTBEGIN,TEXTLINE3,"Adjust the range of values on the X axis");
	}
	else if (strncmp(cmdname, "xscale", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: xscale n");
		graph_text(TEXTBEGIN,TEXTLINE3,"Multiply values on the x axis by n");
	}
	else if (strncmp(cmdname, "xtics", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: xtics n");
		graph_text(TEXTBEGIN,TEXTLINE3,"Set number of grid tics on the x axis (not valid for log(x) mode)");
	}
	else if (strncmp(cmdname, "yaxes", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: yaxes");
		graph_text(TEXTBEGIN,TEXTLINE3,"Turn off/on printing more values along the yaxes.");
	}
	else if (strncmp(cmdname, "yrange", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: yrange >ymin <ymax -a axisnames");
		graph_text(TEXTBEGIN,TEXTLINE3,"Adjust the range of values on the yaxis of specified axes.");
	}
	else if (strncmp(cmdname, "ytics", 2) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"General mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"cmd format: ytics n");
		graph_text(TEXTBEGIN,TEXTLINE3,"Set number of grid tics on the y axis");
	}
	else if (strncmp(cmdname, "scroll", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"not a typed command--hit any mouse button over scroll bars.");
		graph_text(TEXTBEGIN,TEXTLINE3,"To scroll all axes, check mousemap for meaning of buttons.");
	}
	else if (strncmp(cmdname, "shuffle", 3) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient mode only.");
		graph_text(TEXTBEGIN,TEXTLINE2,"not a typed command--select with menu.");
		graph_text(TEXTBEGIN,TEXTLINE3,"To move an axis, check mousemap for meaning of buttons.");
	}
	else if (strncmp(cmdname, "zoom", 1) == 0) {
		graph_text(TEXTBEGIN,TEXTLINE1,"Transient and General modes.");
		graph_text(TEXTBEGIN,TEXTLINE2,"not a typed command--select with menu.");
		graph_text(TEXTBEGIN,TEXTLINE3,"To zoom in, check message area for meaning of buttons.");
	}
	else graph_text(TEXTBEGIN,TEXTLINE1,"Command not identified.");

	graph_text(275.0, TEXTLINE1, "TO CONTINUE, PRESS ANY BUTTON OR KEY");
	graph_await_event(&d1, &d4, &d2, &d3);
}
